<template>
  <accordion
    :id="id"
    ref="accordion"
    class="product-filter"
    placeholder="Фильтр"
    :classes="{
      header: 'filter-heading',
      body: 'filter-box',
      placeholder: 'filter-title',
    }"
    :open="open"
  >
    <template #placeholder>
      <span>Фильтр</span><i class="icon-filter"></i>
    </template>
    <template #after-placeholder>
      <button class="btn btn-link filter-reset" @click="onClearFilters">
        Очистить
      </button>
    </template>
    <template #body>
      <accordion
        v-for="(filter, idx) in filters"
        v-bind="filter"
        :key="idx"
        ref="filters"
        class="filter-item"
      >
        <template #body>
          <ul>
            <li v-for="option in filter.items" :key="filter.id + option.value">
              <label :for="option.value + filter.field + id">{{
                option.name
              }}</label>
              <input
                :id="option.value + filter.field + id"
                v-model="model[filter.field]"
                :value="option.value"
                type="checkbox"
                @change="onSelectFilters"
              />
            </li>
          </ul>
        </template>
      </accordion>
      <button
        class="btn btn-primary w-100 mt-4 d-block"
        @click.prevent="onSubmitFilters"
      >
        Показать
      </button>
    </template>
  </accordion>
</template>

<script>
import Accordion from '@/components/controls/Accordion.vue'
export default {
  name: 'AccordionFilter',
  components: {
    Accordion,
  },
  props: {
    id: {
      type: String,
      required: true,
      default: '',
    },
    open: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    const filters = [...this.$config.filters]
    return {
      filters,
      model: {},
    }
  },
  computed: {
    emptyModel() {
      return Object.fromEntries(
        Object.entries(this.model).map(([key]) => [key, []])
      )
    },
  },
  watch: {
    '$route.query': {
      handler(query) {
        this.model = Object.fromEntries(
          this.filters.map(({ field, items }) => [
            field,
            [].concat(
              query[field] || [],
              items.filter((item) => item.active).flatMap((item) => item.value)
            ),
          ])
        )
      },
      immediate: true,
    },
  },
  methods: {
    onSelectFilters() {
      this.$emit('change', this.model)
    },
    onClearFilters() {
      this.model = Object.assign({}, this.emptyModel)
      this.$emit('clear', {})
    },
    onSubmitFilters() {
      this.$emit('submit', this.model)
    },
  },
}
</script>
